## com.bbn.openmap.plugin
Class WebImagePlugIn

    java.lang.Object
      com.bbn.openmap.plugin.AbstractPlugIn
          com.bbn.openmap.plugin.WebImagePlugIn

All Implemented Interfaces:
  ImageServerConstants, MapMouseListener, PlugIn, PropertyConsumer, WMTConstants

Direct Known Subclasses:
  SHISPlugIn, WMSPlugIn

public abstract class WebImagePlugIn
extends AbstractPlugIn
implements ImageServerConstants

This class asks for an image from a web server. How it asks for that image is what is abstract.

Field Summary
`protected Projection` `currentProjection` The last projection object received.
`protected PlugInLayer` `layer` For convenience.
`protected javax.swing.JOptionPane` `messageWindow`
`protected javax.swing.JButton` `redrawButton`

Fields inherited from class com.bbn.openmap.plugin.AbstractPlugIn
`addToBeanContext, component, i18n, mml, name, prefix, removable, RemovableProperty`

Fields inherited from interface com.bbn.openmap.image.ImageServerConstants
`AZIMUTH, LAT, LAYERMASK, LAYERS, LON, PAN, PROJTYPE, QUERY, RECENTER, SCALE, X, Y`

Fields inherited from interface com.bbn.openmap.image.WMTConstants
`BBOX, BGCOLOR, CAPABILITIES, CRS, EXCEPTIONS, FORMAT, GETCAPABILITIES, GETFEATUREINFO, GETMAP, HEIGHT, IMAGEFORMAT_GEOTIFF, IMAGEFORMAT_GIF, IMAGEFORMAT_JPEG, IMAGEFORMAT_PNG, IMAGEFORMAT_PPM, IMAGEFORMAT_SVG, IMAGEFORMAT_TIFF, IMAGEFORMAT_WBMP, INFO_FORMAT, MAP, QUERY_LAYERS, REQUEST, SERVICE, SRS, STYLES, TRANSPARENT, VERSION, WIDTH, WMTVER`

Fields inherited from interface com.bbn.openmap.PropertyConsumer
`EditorProperty, initPropertiesProperty, LabelEditorProperty, ScopedEditorProperty`

Constructor Summary
`WebImagePlugIn()`

Method Summary
`abstract java.lang.String` `createQueryString(Projection p)` Create the query to be sent to the server, based on current settings.
`java.awt.Component` `getGUI()` Gives the PlugIn a chance to present components that control its attributes.
`OMGraphicList` `getRectangle(Projection p)` The getRectangle call is the main call into the PlugIn module.
`abstract java.lang.String` `getServerName()`
`void` `setComponent(java.awt.Component comp)` Set the component that this PlugIn uses as a grip to the map.

Methods inherited from class com.bbn.openmap.plugin.AbstractPlugIn

`doPrepare, getAddToBeanContext, getComponent, getMapMouseListener, getMouseModeServiceList, getName, getProperties, getPropertyInfo, getPropertyPrefix, isRemovable, mouseClicked, mouseDragged, mouseEntered, mouseExited, mouseMoved, mouseMoved, mousePressed, mouseReleased, removed, repaint, setAddToBeanContext, setMapMouseListener, setName, setProperties, setProperties, setPropertyPrefix, setRemovable`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### layer

    protected PlugInLayer layer

  For convenience.

### currentProjection

    protected Projection currentProjection

  The last projection object received.

### redrawButton

    protected javax.swing.JButton redrawButton

### messageWindow

    protected javax.swing.JOptionPane messageWindow

Constructor Detail

### WebImagePlugIn

    public WebImagePlugIn()

Method Detail

### createQueryString

    public abstract java.lang.String createQueryString(Projection p)

  Create the query to be sent to the server, based on current settings.

### getRectangle

    public OMGraphicList getRectangle(Projection p)

  The getRectangle call is the main call into the PlugIn module. The module is expected to fill the graphics list with objects that are within the screen parameters passed.

  Specified by:
    `getRectangle` in interface `PlugIn`
  Specified by:
    `getRectangle` in class `AbstractPlugIn`
  Parameters:
    `p` - projection of the screen, holding scale, center coords, height, width.

### getServerName

    public abstract java.lang.String getServerName()

### getGUI

    public java.awt.Component getGUI()

  Description copied from interface: `PlugIn`
  Gives the PlugIn a chance to present components that control its attributes.

  Specified by:
    `getGUI` in interface `PlugIn`
  Overrides:
    `getGUI` in class `AbstractPlugIn`

### setComponent

    public void setComponent(java.awt.Component comp)

  Set the component that this PlugIn uses as a grip to the map.

  Specified by:
    `setComponent` in interface `PlugIn`
  Overrides:
    `setComponent` in class `AbstractPlugIn`

Copyright (C) BBNT Solutions LLC; See http://openmap.bbn.com/ for details